#include <bits/stdc++.h>

using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

//using ll = long long;
//#define int long long
const int N = 1e5;
int n;

struct ds {
    int t[8 * N], p[8 * N];

    ds() {
        for (int i = 0; i < 8 * N; ++i) {
            t[i] = 0;
            p[i] = 0;
        }
    }

    void push(int v, int l, int r) {
        if (p[v] != 0) {
            p[2 * v + 1] += p[v];
            p[2 * v + 2] += p[v];
            int m = (l + r) / 2;
            t[2 * v + 1] += p[v] * (m - l);
            t[2 * v + 2] += p[v] * (r - m);
            p[v] = 0;
        }
    }

    void update(int v, int l, int r, int L, int R, int x) {
        if (R <= l || r <= L) {
            return;
        }
        if (L <= l && r <= R) {
            p[v] += x;
            t[v] += x * (r - l);
            return;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, L, R, x);
        update(2 * v + 2, m, r, L, R, x);
        t[v] = t[2 * v + 1] + t[2 * v + 2];
    }

    void update(int l, int r, int x) {
        update(0, 0, n, l, r + 1, x);
    }

    int get(int v, int l, int r, int L, int R) {
        if (R <= l || r <= L) {
            return 0;
        }
        if (L <= l && r <= R) {
            return t[v];
        }
        push(v, l, r);
        int m = (l + r) / 2;
        return get(2 * v + 1, l, m, L, R) + get(2 * v + 2, m, r, L, R);
    }

    int get(int l, int r) {
        return get(0, 0, n, l, r + 1);
    }
};

struct node {
    node *l = nullptr, *r = nullptr, *par = nullptr;
    int sz = 1, num = -1, x = -1;

    node() {}

    node(int pos) : num(pos) {}

};

ds segment_tree;
vector<node *> a;
int tin[N], tout[N], timer = 0;

int getsz(node *v) {
    if (v == nullptr) {
        return 0;
    }
    return v->sz;
}

int getpos(node *v) {
    int k = 1;
    int x = v->x;
    k += (x != -1) * getsz(v->l);
    k += (x == 1) * getsz(v->r);
    while (v->par != nullptr) {
        x = v->par->x;
        if (v->par->l == v) {
            k += (x == -1);
        } else {
            k += getsz(v->par->l) + (x != 1);
        }
        v = v->par;
    }
    return k;
}

vector<node *> Print;

void Dfs(node *v) {
    if (v == nullptr) {
        return;
    }
    Print.emplace_back(v);
    tin[v->num] = timer++;
    Dfs(v->l);
    Dfs(v->r);
    tout[v->num] = timer++;
    v->sz = getsz(v->l) + getsz(v->r) + 1;
}

signed main() {
    fast_in_out();
    int m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        node *nd = new node(i);
        a.emplace_back(nd);
    }
    for (int i = 0; i < n; ++i) {
        int q, w;
        cin >> q >> w;
        --q, --w;
        if (q != -1) {
            a[i]->l = a[q];
            a[q]->par = a[i];
        }
        if (w != -1) {
            a[i]->r = a[w];
            a[w]->par = a[i];
        }
    }
    Dfs(a[0]);
    for (int i = 0; i < n; ++i) {
        segment_tree.update(tin[Print[i]->num], tin[Print[i]->num], i + 1);
        segment_tree.update(tout[Print[i]->num], tout[Print[i]->num], i + 1);
    }
    for (int qwe = 0; qwe < m; ++qwe) {
        int t;
        cin >> t;
        if (t == 1) {
            int l, r, x;
            cin >> l >> r >> x;
            --l, --r;
            for (int i = l; i <= r; ++i) {
                if (a[i]->x == x) continue;
                if (a[i]->x == -1 && x == 0) {
                    if (a[i]->l != nullptr) {
                        segment_tree.update(tin[a[i]->l->num], tout[a[i]->l->num], -1);
                        segment_tree.update(tin[a[i]->num], tin[a[i]->num], getsz(a[i]->l));
                        segment_tree.update(tout[a[i]->num], tout[a[i]->num], getsz(a[i]->l));
                    }
                }
                if (a[i]->x == 0 && x == -1) {
                    if (a[i]->l != nullptr) {
                        segment_tree.update(tin[a[i]->l->num], tout[a[i]->l->num], 1);
                        segment_tree.update(tin[a[i]->num], tin[a[i]->num], -getsz(a[i]->l));
                        segment_tree.update(tout[a[i]->num], tout[a[i]->num], -getsz(a[i]->l));
                    }
                }
                if (a[i]->x == -1 && x == 1) {
                    if (a[i]->l != nullptr) {
                        segment_tree.update(tin[a[i]->l->num], tout[a[i]->l->num], -1);
                    }
                    if (a[i]->r != nullptr) {
                        segment_tree.update(tin[a[i]->r->num], tout[a[i]->r->num], -1);
                    }
                    segment_tree.update(tin[a[i]->num], tin[a[i]->num], getsz(a[i]->l) + getsz(a[i]->r));
                    segment_tree.update(tout[a[i]->num], tout[a[i]->num], getsz(a[i]->l) + getsz(a[i]->r));
                }
                if (a[i]->x == 1 && x == -1) {
                    if (a[i]->l != nullptr) {
                        segment_tree.update(tin[a[i]->l->num], tout[a[i]->l->num], 1);
                    }
                    if (a[i]->r != nullptr) {
                        segment_tree.update(tin[a[i]->r->num], tout[a[i]->r->num], 1);
                    }
                    segment_tree.update(tin[a[i]->num], tin[a[i]->num], -(getsz(a[i]->l) + getsz(a[i]->r)));
                    segment_tree.update(tout[a[i]->num], tout[a[i]->num], -(getsz(a[i]->l) + getsz(a[i]->r)));
                }
                if (a[i]->x == 0 && x == 1) {
                    if (a[i]->r != nullptr) {
                        segment_tree.update(tin[a[i]->r->num], tout[a[i]->r->num], -1);
                        segment_tree.update(tin[a[i]->num], tin[a[i]->num], getsz(a[i]->r));
                        segment_tree.update(tout[a[i]->num], tout[a[i]->num], getsz(a[i]->r));
                    }
                }
                if (a[i]->x == 1 && x == 0) {
                    if (a[i]->r != nullptr) {
                        segment_tree.update(tin[a[i]->r->num], tout[a[i]->r->num], 1);
                        segment_tree.update(tin[a[i]->num], tin[a[i]->num], -getsz(a[i]->r));
                        segment_tree.update(tout[a[i]->num], tout[a[i]->num], -getsz(a[i]->r));
                    }
                }
                a[i]->x = x;
            }
        } else {
            int v;
            cin >> v;
            --v;
            cout  << getpos(a[v]) << '\n';
        }
    }
    return 0;
}