#include <bits/stdc++.h>

using namespace std;

void fast_in_out() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
}

//using ll = long long;
//#define int long long
const int N = 1e5;
int n;

struct ds {
    int t[4 * N];

    ds() {
        t[0] = -1;
        for (int i = 1; i < 4 * N; ++i) {
            t[i] = 5;
        }
    }

    void push(int v) {
        if (t[v] != 5) {
            t[2 * v + 1] = t[v];
            t[2 * v + 2] = t[v];
            t[v] = 5;
        }
    }

    void update(int v, int l, int r, int L, int R, int x) {
        if (R <= l || r <= L) {
            return;
        }
        if (L <= l && r <= R) {
            t[v] = x;
            return;
        }
        push(v);
        int m = (l + r) / 2;
        update(2 * v + 1, l, m, L, R, x);
        update(2 * v + 2, m, r, L, R, x);
    }

    void update(int l, int r, int x) {
        update(0, 0, n, l, r + 1, x);
    }

    int get(int v, int l, int r, int pos) {
        if (l + 1 == r) {
            return t[v];
        }
        push(v);
        int m = (l + r) / 2;
        if (pos < m) {
            return get(2 * v + 1, l, m, pos);
        } else {
            return get(2 * v + 2, m, r, pos);
        }
    }

    int get(int pos) {
        return get(0, 0, n, pos);
    }
};

struct node {
    node *l = nullptr, *r = nullptr, *par = nullptr;
    int sz = 1, num = -1;

    node() {}

    node(int pos) : num(pos) {}

};

ds segment_tree;
vector<node *> a;

int getsz(node *v) {
    if (v == nullptr) {
        return 0;
    }
    return v->sz;
}

int getpos(node *v) {
    int k = 1;
    int x = segment_tree.get(v->num);
    k += (x != -1) * getsz(v->l);
    k += (x == 1) * getsz(v->r);
    while (v->par != nullptr) {
        x = segment_tree.get(v->par->num);
        if (v->par->l == v) {
            k += (x == -1);
        } else {
            k += getsz(v->par->l) + (x != 1);
        }
        v = v->par;
    }
    return k;
}

void Dfs(node *v) {
    if (v == nullptr) {
        return;
    }
    Dfs(v->l);
    Dfs(v->r);
    v->sz = getsz(v->l) + getsz(v->r) + 1;
}

signed main() {
    fast_in_out();
    int m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        node *nd = new node(i);
        a.emplace_back(nd);
    }
    for (int i = 0; i < n; ++i) {
        int q, w;
        cin >> q >> w;
        --q, --w;
        if (q != -1) {
            a[i]->l = a[q];
            a[q]->par = a[i];
        }
        if (w != -1) {
            a[i]->r = a[w];
            a[w]->par = a[i];
        }
    }
    Dfs(a[0]);
    for (int qwe = 0; qwe < m; ++qwe) {
        int t;
        cin >> t;
        if (t == 1) {
            int l, r, x;
            cin >> l >> r >> x;
            --l, --r;
            segment_tree.update(l, r, x);
        } else {
            int v;
            cin >> v;
            --v;
            cout << getpos(a[v]) << '\n';
        }
    }
    return 0;
}